function Create(self)
print "Main Battle Platform Initialized";
	-- flight control variables
	self.ToVel = Vector(0,0);
	self.jetOn = true;
	self.FloatHeight = 111;
	self.maxspeed = 5;
	self.minspeed = .25;
	self.stabilization = 1;
	
	-- AI variables
	self.AIoverride = false;
	
	-- mining beam variables
	self.firetime = Timer();
	self.firerate = 25; -- higher = slower
	self.laserRange = 9001; -- OVER NINE THOUSAND
	self.hitVel = 100;
	self.AimAngle = 4.712; -- AIM DOWN
	self.AimVariation = 3;
	self.clicktimer = Timer();
	self.tofire = false;
end

function Update(self)
	local ownController = self:GetController(); 
	
	if self.Health < 10 then self.stabilization = false; 
		if self.Health < 5 then
			self.jetOn = false; 
		end
	end

-- BEGIN MANUAL CONTROL SYSTEM --
	if self.jetOn and not self.AIoverride then
		if ownController:IsState(Controller.HOLD_LEFT) then
			self.ToVel.X = self.ToVel.X - 0.2;
		elseif ownController:IsState(Controller.HOLD_RIGHT) then
			self.ToVel.X = self.ToVel.X + 0.2;
		elseif not ownController:IsState(Controller.HOLD_LEFT) and not ownController:IsState(Controller.HOLD_RIGHT) then
			self.ToVel.X = self.ToVel.X / 1.02;  if math.abs(self.ToVel.X) < self.minspeed then self.ToVel.X = 0; end
		end
		if ownController:IsState(Controller.HOLD_DOWN) then
			self.ToVel.Y = self.ToVel.Y + 0.25;
		elseif ownController:IsState(Controller.HOLD_UP) then
			self.ToVel.Y = self.ToVel.Y - 0.5;
		elseif not ownController:IsState(Controller.HOLD_UP) and not ownController:IsState(Controller.HOLD_DOWN) then
			self.ToVel.Y = self.ToVel.Y / 1.02;  if math.abs(self.ToVel.Y) < self.minspeed then self.ToVel.Y = 0; end
		end
		-- speed limiters
		if self.ToVel.X > self.maxspeed then
			self.ToVel.X = self.maxspeed;
		elseif self.ToVel.X < -1*self.maxspeed then
			self.ToVel.X = -1*self.maxspeed;
		end
		if self.ToVel.Y > self.maxspeed then
			self.ToVel.Y = self.maxspeed;
		elseif self.ToVel.Y < -1*self.maxspeed then
			self.ToVel.Y = -1*self.maxspeed;
		end
	end
	if self:GetController():IsState(Controller.WEAPON_FIRE) and self.clicktimer:IsPastRealMS(700) then
		if self.tofire == true then
			print "toggle to false";
			self.tofire = false;
			self.AIoverride = false;
			self.clicktimer:Reset();
		else
			print "toggle to true";
			self.tofire = true;
			self.clicktimer:Reset();
			self.AIoverride = true;
			-- now set a target on the ground and spawn the target painter stuff
		end
	end
-- END MANUAL CONTROL SYSTEM --



-- BEGIN MINING BEAM CONTROL --
	if self.tofire == true and self.firetime:IsPastSimMS(self.firerate) == true then
		local checkVect = Vector(0,0);
		checkVect.X = math.cos(self.AimAngle) * self.laserRange;
		checkVect.Y = math.sin(self.AimAngle) * self.laserRange * -1;
		self.AimAngle = self.AimAngle - 0.002;
		if self.AimAngle < 4.538 then self.AimAngle = 4.887; end
		local length = SceneMan:CastObstacleRay(self.Pos, checkVect, Vector(0,0), Vector(0,0), self.ID, -1, 3);
		if length > -1 then
			self.particle = CreateAEmitter("Orbital Weapon","Smart Mortar.rte");
			self.particle.Pos = Vector(self.Pos.X + length * math.cos(self.AimAngle), self.Pos.Y - length * math.sin(self.AimAngle))
			MovableMan:AddMO(self.particle);
			local power = (10 * math.random(1,5));
			for gold in MovableMan.Particles do
				local distVec = self.particle.Pos - gold.Pos;
				-- the mass of gold is 0.0283495, use that later
				if distVec.Magnitude < power then
					gold.Vel = Vector(0,-25);
				end
			end
		end
		self.firetime:Reset();
	end
-- END MINING BEAM CONTROL --



-- BEGIN AUTOMATIC SYSTEM CONTROLS -- 
	-- attempt to keep the ship from crashing
	self.Altitude = self:GetAltitude(400,1); if self.Altitude < self.FloatHeight then self.ToVel.Y = self.ToVel.Y /2 ; self.ToVel.Y = self.ToVel.Y - (self.FloatHeight - self.Altitude)/10; end

	-- while stabilization is active, keep the ship level	
	if self.stabilization then self.RotAngle = 0; end

	-- send the current velocity variables to the "engines" 
	--/////THIS HAPPENS LAST/////--
	self.Vel.X = self.ToVel.X;
	self.Vel.Y = self.ToVel.Y;
-- END AUTOMATIC SYSTEM CONTROLS -- 


end
function Destroy(self)
	print "Main Battle Platform Destroyed";
end